// 双向链表的插入函数
// 要点：
//     在有序双向链表中插入新的节点，并保持新链表的有序性
// 关键字：有序双向链表

#include <stdlib.h>

typedef struct DLNode {
  struct DLNode* r;
  struct DLNode* l;
  int data;
}dnode;
////////////////////////////////////声明结构体自引用l，r域构成双向链表///////////////////////////////
//@ shape l, r: dlist;

///////////////////////////////////////////声明逻辑变量////////////////////////////////////////////
//@ logic int n;
//@ logic dnode* oldp;

/////////////////////////////////////insertNode函数的验证/////////////////////////////////////////
//函数协议：
//函数前条件：p为空或者指向长度为n的有序双向链表
//函数后条件：返回值指向长为n+1的有序双向链表

/*@ 
  requires 
      p == \null && n == 0 && oldp == p 
    || 
      p != \null && \dlist(p) && \length(p,r) == n && 1 <= n <= 1000 && oldp == p 
      && \forall integer i:[0..n-2].p->(r:i)->data <= p->(r:i+1)->data
      ;
  assigns oldp;
  exits 
      \exit_status == 1
      ;
  ensures 
      \dlist(\result) && \length(\result, r) == n + 1 
      && (
          oldp == \null //函数入口处头节点为空
        || 
          oldp == \result//函数入口处头节点为新链表的头节点
        || 
          oldp == \result->(r:1)//函数入口处头节点为新链表的头节点
         )
      && \forall integer i:[0..n-1]. \result->(r:i)->data <= \result->(r:i+1)->data
      ;
*/
dnode* insertNode(dnode* p, int const data)/*@ shape dnode forward: r;*/{
    dnode* q;
    dnode* s;
    int j;

    s = (dnode*)malloc(sizeof(dnode));
    if(s == NULL){
    exit(1);
    }
    s->data = data;
    if(p == NULL){            // 插入空表。
    p = s;
    p->l = NULL;
    p->r = NULL;    
    }
    else{
    q = p;
    j = 0;
    /*@ 
      loop invariant
          1 <= n <= 1000 
          //整体描述双向链表
          && \dlist(p) && \length(p,r) == n 
          && q == p->(r:j) 
          && oldp == p 
          //描述待插入节点的性质
          && \singleton(s) && s->data == data 
          //对应循环不变式整体描述链表有序性
          && (\forall integer i:[0..n-2].p->(r:i)->data <= p->(r:i+1)->data) 
          && (
              //1.循环入口
              j == 0 
            || 
              //2.循环出口
              0 < j <= n-1 
              && p->(r:j-1)->data < data
              )
          ;
    */
    while(q->data < data && q->r != NULL){
        q = q->r;
        j = j + 1;
    }
    if(q->data >= data){        // 插在这n个节点之间的某个位置。
        s->l = q->l;
        q->l = s;
        if (s->l == NULL) {        // 插在第一个节点之前。
                p = s;
            }
            else {
                s->l->r = s;
            }
            s->r = q;
        }
        else {                // 插在最后一个节点之后。
            s->l = q;
            s->r = NULL;
            q->r = s;
        }    
    }
    return p;
}
